VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2310
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4770
   LinkTopic       =   "Form1"
   ScaleHeight     =   2310
   ScaleWidth      =   4770
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView lvwEmployees 
      Height          =   2295
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   4695
      _ExtentX        =   8281
      _ExtentY        =   4048
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Return a string giving the element names and attributes
' for this node's subtree separated by | characters.
Private Function GetAttributesAndNames(ByVal xml_node As IXMLDOMElement) As String
Dim result As String
Dim i As Integer
Dim child As IXMLDOMNode

    ' Get this element's attributes.
    result = ""
    For i = 0 To xml_node.Attributes.length - 1
        result = result & "|" & _
            xml_node.nodeName & " " & _
            xml_node.Attributes(i).nodeName
    Next i

    ' If the element has a single text child,
    ' add the element's name.
    If (xml_node.childNodes.length = 1) And _
       (xml_node.firstChild.nodeType = NODE_TEXT) _
    Then
        ' It's a text node. Use its name.
        result = result & "|" & xml_node.nodeName
    Else
        ' Get the sub-tree's names and attributes.
        For Each child In xml_node.childNodes
            If TypeOf child Is IXMLDOMElement Then
                result = result & "|" & GetAttributesAndNames(child)
            End If
        Next child
    End If

    If Len(result) > 0 Then result = Mid$(result, 2)
    GetAttributesAndNames = result
End Function
' Return a string giving the values of element names and attributes
' for this node's subtree separated by | characters.
Private Function GetAttributeAndNameValues(ByVal xml_node As IXMLDOMElement) As String
Dim result As String
Dim i As Integer
Dim child As IXMLDOMNode

    ' Get this element's attribute values.
    result = ""
    For i = 0 To xml_node.Attributes.length - 1
        result = result & "|" & _
            xml_node.Attributes(i).Text
    Next i

    ' If the element has a single text child,
    ' add the text.
    If (xml_node.childNodes.length = 1) And _
       (xml_node.firstChild.nodeType = NODE_TEXT) _
    Then
        ' It's a text node. Use its name.
        result = result & "|" & xml_node.firstChild.Text
    Else
        ' Get the sub-tree's name and attribute values.
        For Each child In xml_node.childNodes
            If TypeOf child Is IXMLDOMElement Then
                result = result & "|" & GetAttributeAndNameValues(child)
            End If
        Next child
    End If

    If Len(result) > 0 Then result = Mid$(result, 2)
    GetAttributeAndNameValues = result
End Function

Private Sub Form_Load()
Dim file_name As String
Dim xml_doc As DOMDocument
Dim root_node As IXMLDOMElement
Dim employee_node As IXMLDOMElement
Dim txt As String
Dim values() As String
Dim i As Integer
Dim lvw_item As ListItem

    ' Compose the XML file's name.
    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "Employees.xml"

    ' Read the XML file.
    Set xml_doc = New DOMDocument
    xml_doc.Load file_name
    Set root_node = xml_doc.documentElement

    ' Use the first Employee node to make the column headers.
    Set employee_node = root_node.firstChild
    txt = GetAttributesAndNames(employee_node)
    values = Split(txt, "|")
    For i = 0 To UBound(values)
        lvwEmployees.ColumnHeaders.Add Text:=values(i)
    Next i

    ' Read the Employee values.
    For Each employee_node In root_node.childNodes
        txt = GetAttributeAndNameValues(employee_node)
        values = Split(txt, "|")
        If UBound(values) > 0 Then
            Set lvw_item = lvwEmployees.ListItems.Add(Text:=values(0))
            For i = 1 To UBound(values)
                lvw_item.ListSubItems.Add Text:=values(i)
            Next i
        End If
    Next employee_node
End Sub


Private Sub Form_Resize()
    lvwEmployees.Move 0, 0, ScaleWidth, ScaleHeight
End Sub


